"use strict";const debug=require("debug")("ali-rds:operator"),SqlString=require("./sqlstring"),literals=require("./literals"),wrap=require("co-wrap-all");function Operator(){}module.exports=Operator;const proto=Operator.prototype;proto.literals=literals,proto.escape=function(t,e,r){return SqlString.escape(t,e,r)},proto.escapeId=function(t,e){return SqlString.escapeId(t,e)},proto.format=function(t,e,r,o){return Array.isArray(e)||"object"!=typeof e||null===e?SqlString.format(t,e,r,o):t.replace(/\:(\w+)/g,function(t,r){return e.hasOwnProperty(r)?SqlString.escape(e[r]):t})},proto.query=function*(t,e){arguments.length>=2&&(t=this.format(t,e)),debug("query %j",t);try{const e=yield this._query(t);return debug("query get %d rows",e.length),e}catch(e){throw e.stack=e.stack+"\n    sql: "+t,debug("query error: %s",e),e}},proto.queryOne=function*(t,e){const r=yield this.query(t,e);return r&&r[0]||null},proto._query=function(){throw new Error("SubClass must impl this")},proto.count=function*(t,e){let r;if("string"==typeof t)r=this.format("SELECT COUNT(*) as count FROM ??",[t])+this._where(e);else if(Array.isArray(t)){let o=[];for(let r in t)o.push(this.format("SELECT COUNT(*) as count FROM ??",[t[r]])+this._where(e));r=o.join(" UNION ALL ")}debug("count(%j, %j) \n=> %j",t,e,r);const o=yield this.query(r);let n=0;for(let t in o)n+=o[t].count;return n},proto.select=function*(t,e){e=e||{};const r=this._selectColumns(t,e.columns,e.where)+this._orders(e.orders)+this._limit(e.limit,e.offset);return debug("select(%j, %j) \n=> %j",t,e,r),yield this.query(r)},proto.get=function*(t,e,r){(r=r||{}).where=e,r.limit=1,r.offset=0;const o=yield this.select(t,r);return o&&o[0]||null},proto.insert=function*(t,e,r){let o;if(r=r||{},Array.isArray(e)){for(let t in e)e[t].created_at=e[t].created_at?e[t].created_at:literals.now,e[t].updated_at=e[t].updated_at?e[t].updated_at:literals.now;o=e[0]}else e.created_at=e.created_at?e.created_at:literals.now,e.updated_at=e.updated_at?e.updated_at:literals.now,o=e,e=[e];r.columns||(r.columns=Object.keys(o));const n=[t,r.columns],s=[];for(let t=0;t<e.length;t++){const o=[],i=e[t];for(let t=0;t<r.columns.length;t++)o.push(i[r.columns[t]]);s.push("(?)"),n.push(o)}let i="";r.Literal&&(i=r.Literal);const u=this.format("INSERT INTO ??(??) VALUES"+s.join(", ")+i,n);return debug("insert(%j, %j, %j) \n=> %j",t,e,r,u),yield this.query(u)},proto.update=function*(t,e,r){if((r=r||{}).columns||(e.updated_at=literals.now,r.columns=Object.keys(e)),!r.where){if(!("id"in e))throw new Error("Can not auto detect update condition, please set options.where, or make sure obj.id exists");r.where={id:e.id}}const o=[],n=[];for(let s=0;s<r.columns.length;s++){const i=r.columns[s];i in r.where?console.warn("DB Update: ",t,e,r):"Literal"!=i?(o.push("?? = ?"),n.push(i),n.push(e[i])):(o.push("?"),n.push(literals.Literal(e[i])))}const s=this.format("UPDATE ?? SET ",[t])+this.format(o.join(", "),n)+this._where(r.where);return debug("update(%j, %j, %j) \n=> %j",t,e,r,s),yield this.query(s)},proto.updateRows=function*(t,e){if(!Array.isArray(e))throw new Error("Options should be array");const r={},o={};e.forEach(t=>{if(!(t.hasOwnProperty("id")||t.row&&t.where))throw new Error("Can not auto detect updateRows condition, please set option.row and option.where, or make sure option.id exists");if(t.hasOwnProperty("id")){const e={id:t.id},r=Object.keys(t).reduce((e,r)=>("id"!==r&&(e[r]=t[r]),e),{});t={row:r,where:e}}let e=this._where(t.where);e=-1===e.indexOf("WHERE")?e:e.substring(e.indexOf("WHERE")+5);for(const o in t.row)r[o]||(r[o]={when:[],then:[]}),r[o].when.push(" WHEN "+e+" THEN ? "),r[o].then.push(t.row[o]);for(const e in t.where)o[e]||(o[e]=[]),-1===o[e].indexOf(t.where[e])&&o[e].push(t.where[e])});let n=["UPDATE ?? SET "],s=[t];const i=[];for(const t in r){let e=" ?? = CASE ";s.push(t),e+=r[t].when.join(" "),s=s.concat(r[t].then),e+=" ELSE ?? END ",i.push(e),s.push(t)}n+=i.join(" , "),n+=this._where(o);const u=this.format(n,s);return debug("updateRows(%j, %j) \n=> %j",t,e,u),yield this.query(u)},proto.delete=function*(t,e){const r=this.format("DELETE FROM ??",[t])+this._where(e);return debug("delete(%j, %j) \n=> %j",t,e,r),yield this.query(r)},proto._where=function(t){if(!t)return"";const e=[],r=[];for(const o in t){const n=t[o];if(Array.isArray(n))e.push("?? IN (?)");else if(null===n||void 0===n)e.push("?? IS ?");else{if("Literal"==o){e.push("?"),r.push(literals.Literal(n));continue}e.push("?? = ?")}r.push(o),r.push(n)}return e.length>0?this.format(" WHERE "+e.join(" AND "),r):""},proto._selectColumns=function(t,e,r){let o;if(e||(e="*"),"string"==typeof t)o="*"===e?this.format("SELECT * FROM ??",[t])+this._where(r):this.format("SELECT ?? FROM ??",[e,t])+this._where(r);else if(Array.isArray(t)){let n=[];if("*"===e)for(let e in t)n.push(this.format("SELECT * FROM ??",[t[e]])+this._where(r));else for(let o in t)n.push(this.format("SELECT ?? FROM ??",[e,t[o]])+this._where(r));o=n.join(" UNION ALL ")}return o},proto._orders=function(t){if(!t)return"";"string"==typeof t&&(t=[t]);const e=[];for(let r=0;r<t.length;r++){const o=t[r];if("string"==typeof o)e.push(this.escapeId(o));else if(Array.isArray(o)){let t=String(o[1]).toUpperCase();"ASC"!==t&&"DESC"!==t&&(t=null),t?e.push(this.escapeId(o[0])+" "+t):e.push(this.escapeId(o[0]))}}return" ORDER BY "+e.join(", ")},proto._limit=function(t,e){return t&&"number"==typeof t?("number"!=typeof e&&(e=0)," LIMIT "+e+", "+t):""},wrap(proto);